/** @file InfinibandVerbs.h
 *  @brief Infiniband Verbs topology detection and description
 */

#ifndef PADICO_INFINIBAND_VERBS_H
#define PADICO_INFINIBAND_VERBS_H

#include <Padico/Puk.h>
#include <Padico/Topology.h>

#include <infiniband/verbs.h>
#include <infiniband/arch.h>

/** an active IB port */
struct padico_ibv_port_s
{
  struct ibv_context*context; /**< IB context of the device */
  const char*devname;         /**< name of the HCA device */
  int      port_num;          /**< IB port number */
  uint64_t guid;              /**< GUID of the HCA device */
  uint64_t subnet;            /**< GID prefix of the local subnet */
  uint16_t port_lid;          /**< LID for the local IB port */
  padico_topo_network_t network;
};

PUK_VECT_TYPE(padico_ibv_port, struct padico_ibv_port_s*);

const struct padico_ibv_port_vect_s*padico_ibv_get_ports(void);


#endif /* PADICO_INFINIBAND_VERBS_H */
