
#include <Padico/Puk.h>
#include <Padico/Topology.h>
#include "ParallelStreams.h"

/** Magic ID for connection establishment
 * ParallelStreams 2.0 
 */
#define PS_MAGIC {'P', 'S', '.', '2'}

/** The default block size for interleaving. Best result for
 *  block = k*1460 on Ethernet
 * @note should be a string, not an int.
 */
#define PS_DEFAULT_BLOCK_SIZE  "4380"

/** The default number of parallel streams.
 * @note should be a string, not an int.
 */
#define PS_DEFAULT_NUM_WAYS    "4"

struct ps_stream_state_s
{
  int pos;
  int block;
};

struct vlink_ps_specific_s
{
  struct ps_params_s params;
  struct ps_stream_state_s send;
  struct ps_stream_state_s recv;
  int*fds;
  padico_io_t*outs;
  padico_io_t*ins;
  int server_fd;
  padico_io_t server_io;
};


struct ps_connection_header_s
{
  uint8_t  ps_magic[4];
  uint32_t num_way;
};
