/** @file Hardcoded connection to a SOCKS4 proxy
 */

#include <Padico/Module.h>
#include <Padico/Puk.h>
#include "ProxyFactory.h"

PADICO_MODULE_DECLARE(Proxy_SOCKS4);
PADICO_MODULE_INIT(proxy_socks4_init);


static int  proxy_socks4_create(const struct sockaddr**addr, socklen_t*addrlen);
static void proxy_socks4_release(void);

static const struct padico_proxyfactory_s proxy_socks4_driver =
  {
    .create  = &proxy_socks4_create,
    .release = &proxy_socks4_release
  };

static int proxy_socks4_init(void)
{
  puk_component_declare("Proxy-SOCKS4",
			puk_component_provides("ProxyFactory", "proxy", &proxy_socks4_driver),
			puk_component_attr("gateway", "localhost"));
  return 0;
}

static int  proxy_socks4_create(const struct sockaddr**addr, socklen_t*addrlen)
{
  
  return 0;
}

static void proxy_socks4_release(void)
{
}
