#! /usr/bin/env -S Rscript --no-save

library(ggplot2)
library(tidyr)
library(stringr)

args <- commandArgs(trailingOnly=TRUE)
df <- lapply(args,read.table,header=FALSE)
vec=NULL

fix.labels <- function(x){
    x + 1
}
temp <- extract(data.frame(df[1]),V1, c("theoretical"), "\\[([[:digit:]]+)-[[:digit:]]+-[[:digit:]]+\\.[[:digit:]]+\\]", convert=TRUE)
theoretical <- temp$theoretical
for (i in 1:12){
for(j in 1:length(df)){
  vec[j] = data.frame(df[j])$V2[i]
}
df2 <-data.frame(matrix(NA,ncol=0,nrow=length(args)))
df2$ratio <- vec
df2$names <- args
names <- lapply(args,str_remove,pattern="_CI.dat")
ggplot(data=df2, aes(x=as.numeric(row.names(df2)),y=df2$ratio - 1)) + geom_col() + labs(title = paste("Compute impact",theoretical[i])) + scale_x_discrete("",labels=c(names),breaks=c(1:length(args)),limits=c(1:length(args))) + scale_y_continuous(name="ratio",labels=fix.labels,limits=c(-1,1)) + theme(axis.text.x=element_text(angle=-90))+ geom_hline(yintercept=0,color = "red",size=0.1)


ggsave(paste(theoretical[i],"us.pdf",sep=""), width = 9, height = 8, dpi = 1200)

}
