MODULE MPI_BASE
  IMPLICIT NONE
  INTERFACE
     ! Fortran bindings
     ! Point-to-Point Communication
     !
     SUBROUTINE MPI_CANCEL(REQUEST, IERROR)
       INTEGER REQUEST, IERROR
     END SUBROUTINE MPI_CANCEL
     !
     SUBROUTINE MPI_GET_COUNT(STATUS, DATATYPE, COUNT, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       INTEGER STATUS(MPI_STATUS_SIZE), DATATYPE, COUNT, IERROR
     END SUBROUTINE MPI_GET_COUNT
     !
     SUBROUTINE MPI_IMPROBE(SOURCE, TAG, COMM, FLAG, MESSAGE, STATUS, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       INTEGER SOURCE, TAG, COMM, MESSAGE, STATUS(MPI_STATUS_SIZE), IERROR
       LOGICAL FLAG
     END SUBROUTINE MPI_IMPROBE
     !
     SUBROUTINE MPI_IPROBE(SOURCE, TAG, COMM, FLAG, STATUS, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       LOGICAL FLAG
       INTEGER SOURCE, TAG, COMM, STATUS(MPI_STATUS_SIZE), IERROR
     END SUBROUTINE MPI_IPROBE
     !
     SUBROUTINE MPI_MPROBE(SOURCE, TAG, COMM, MESSAGE, STATUS, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       INTEGER SOURCE, TAG, COMM, MESSAGE, STATUS(MPI_STATUS_SIZE), IERROR
     END SUBROUTINE MPI_MPROBE
     !
     SUBROUTINE MPI_PROBE(SOURCE, TAG, COMM, STATUS, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       INTEGER SOURCE, TAG, COMM, STATUS(MPI_STATUS_SIZE), IERROR
     END SUBROUTINE MPI_PROBE
     !
     SUBROUTINE MPI_REQUEST_FREE(REQUEST, IERROR)
       INTEGER REQUEST, IERROR
     END SUBROUTINE MPI_REQUEST_FREE
     !
     SUBROUTINE MPI_REQUEST_GET_STATUS( REQUEST, FLAG, STATUS, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       INTEGER REQUEST, STATUS(MPI_STATUS_SIZE), IERROR
       LOGICAL FLAG
     END SUBROUTINE MPI_REQUEST_GET_STATUS
     !
     SUBROUTINE MPI_START(REQUEST, IERROR)
       INTEGER REQUEST, IERROR
     END SUBROUTINE MPI_START
     !
     SUBROUTINE MPI_STARTALL(COUNT, ARRAY_OF_REQUESTS, IERROR)
       INTEGER COUNT, ARRAY_OF_REQUESTS(*), IERROR
     END SUBROUTINE MPI_STARTALL
     !
     SUBROUTINE MPI_TEST(REQUEST, FLAG, STATUS, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       LOGICAL FLAG
       INTEGER REQUEST, STATUS(MPI_STATUS_SIZE), IERROR
     END SUBROUTINE MPI_TEST
     !
     SUBROUTINE MPI_TESTALL(COUNT, ARRAY_OF_REQUESTS, FLAG, ARRAY_OF_STATUSES, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       LOGICAL FLAG
       INTEGER COUNT, ARRAY_OF_REQUESTS(*), ARRAY_OF_STATUSES(MPI_STATUS_SIZE,*), IERROR
     END SUBROUTINE MPI_TESTALL
     !
     SUBROUTINE MPI_TESTANY(COUNT, ARRAY_OF_REQUESTS, INDEX, FLAG, STATUS, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       LOGICAL FLAG
       INTEGER COUNT, ARRAY_OF_REQUESTS(*), INDEX, STATUS(MPI_STATUS_SIZE), IERROR
     END SUBROUTINE MPI_TESTANY
     !
     SUBROUTINE MPI_TESTSOME(INCOUNT, ARRAY_OF_REQUESTS, OUTCOUNT, ARRAY_OF_INDICES,&
          ARRAY_OF_STATUSES, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       INTEGER INCOUNT, ARRAY_OF_REQUESTS(*), OUTCOUNT, ARRAY_OF_INDICES(*),&
            ARRAY_OF_STATUSES(MPI_STATUS_SIZE,*), IERROR
     END SUBROUTINE MPI_TESTSOME
     !
     SUBROUTINE MPI_TEST_CANCELLED(STATUS, FLAG, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       LOGICAL FLAG
       INTEGER STATUS(MPI_STATUS_SIZE), IERROR
     END SUBROUTINE MPI_TEST_CANCELLED
     !
     SUBROUTINE MPI_WAIT(REQUEST, STATUS, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       INTEGER REQUEST, STATUS(MPI_STATUS_SIZE), IERROR
     END SUBROUTINE MPI_WAIT
     !
     SUBROUTINE MPI_WAITALL(COUNT, ARRAY_OF_REQUESTS, ARRAY_OF_STATUSES, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       INTEGER COUNT, ARRAY_OF_REQUESTS(*)
       INTEGER ARRAY_OF_STATUSES(MPI_STATUS_SIZE,*), IERROR
     END SUBROUTINE MPI_WAITALL
     !
     SUBROUTINE MPI_WAITANY(COUNT, ARRAY_OF_REQUESTS, INDEX, STATUS, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       INTEGER COUNT, ARRAY_OF_REQUESTS(*), INDEX, STATUS(MPI_STATUS_SIZE), IERROR
     END SUBROUTINE MPI_WAITANY
     !
     SUBROUTINE MPI_WAITSOME(INCOUNT, ARRAY_OF_REQUESTS, OUTCOUNT,&
          ARRAY_OF_INDICES, ARRAY_OF_STATUSES, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       INTEGER INCOUNT, ARRAY_OF_REQUESTS(*), OUTCOUNT,&
            ARRAY_OF_INDICES(*), ARRAY_OF_STATUSES(MPI_STATUS_SIZE,*), IERROR
     END SUBROUTINE MPI_WAITSOME
     !

     ! Datatypes
     !
     SUBROUTINE MPI_GET_ELEMENTS(STATUS, DATATYPE, COUNT, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       INTEGER STATUS(MPI_STATUS_SIZE), DATATYPE, COUNT, IERROR
     END SUBROUTINE MPI_GET_ELEMENTS
     !
     SUBROUTINE MPI_GET_ELEMENTS_X(STATUS, DATATYPE, COUNT, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE, MPI_COUNT_KIND
       INTEGER STATUS(MPI_STATUS_SIZE), DATATYPE, IERROR
       INTEGER(KIND=MPI_COUNT_KIND) COUNT
     END SUBROUTINE MPI_GET_ELEMENTS_X
     !
     SUBROUTINE MPI_PACK_EXTERNAL_SIZE(DATAREP, INCOUNT, DATATYPE, SIZE, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER INCOUNT, DATATYPE, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) SIZE
       CHARACTER (LEN=*) DATAREP
     END SUBROUTINE MPI_PACK_EXTERNAL_SIZE
     !
     SUBROUTINE MPI_PACK_SIZE(INCOUNT, DATATYPE, COMM, SIZE, IERROR)
       INTEGER INCOUNT, DATATYPE, COMM, SIZE, IERROR
     END SUBROUTINE MPI_PACK_SIZE
     !
     SUBROUTINE MPI_TYPE_COMMIT(DATATYPE, IERROR)
       INTEGER DATATYPE, IERROR
     END SUBROUTINE MPI_TYPE_COMMIT
     !
     SUBROUTINE MPI_TYPE_CONTIGUOUS(COUNT, OLDTYPE, NEWTYPE, IERROR)
       INTEGER COUNT, OLDTYPE, NEWTYPE, IERROR
     END SUBROUTINE MPI_TYPE_CONTIGUOUS
     !
     SUBROUTINE MPI_TYPE_CREATE_DARRAY(SIZE, RANK, NDIMS,&
          ARRAY_OF_GSIZES, ARRAY_OF_DISTRIBS, ARRAY_OF_DARGS,&
          ARRAY_OF_PSIZES, ORDER, OLDTYPE, NEWTYPE, IERROR)
       INTEGER SIZE, RANK, NDIMS, ARRAY_OF_GSIZES(*),&
            ARRAY_OF_DISTRIBS(*), ARRAY_OF_DARGS(*), ARRAY_OF_PSIZES(*),&
            ORDER, OLDTYPE, NEWTYPE, IERROR
     END SUBROUTINE MPI_TYPE_CREATE_DARRAY
     !
     SUBROUTINE MPI_TYPE_CREATE_HINDEXED(COUNT,&
          ARRAY_OF_BLOCKLENGTHS, ARRAY_OF_DISPLACEMENTS, OLDTYPE, NEWTYPE, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER COUNT, ARRAY_OF_BLOCKLENGTHS(*), OLDTYPE, NEWTYPE, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) ARRAY_OF_DISPLACEMENTS(*)
     END SUBROUTINE MPI_TYPE_CREATE_HINDEXED
     !
     SUBROUTINE MPI_TYPE_CREATE_HINDEXED_BLOCK(COUNT, BLOCKLENGTH, ARRAY_OF_DISPLACEMENTS,&
          OLDTYPE, NEWTYPE, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER COUNT, BLOCKLENGTH, OLDTYPE, NEWTYPE, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) ARRAY_OF_DISPLACEMENTS(*)
     END SUBROUTINE MPI_TYPE_CREATE_HINDEXED_BLOCK
     !
     SUBROUTINE MPI_TYPE_CREATE_HVECTOR(COUNT, BLOCKLENGTH, STRIDE,&
          OLDTYPE, NEWTYPE, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER COUNT, BLOCKLENGTH, OLDTYPE, NEWTYPE, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) STRIDE
     END SUBROUTINE MPI_TYPE_CREATE_HVECTOR
     !
     SUBROUTINE MPI_TYPE_CREATE_INDEXED_BLOCK(COUNT, BLOCKLENGTH,&
          ARRAY_OF_DISPLACEMENTS, OLDTYPE, NEWTYPE, IERROR)
       INTEGER COUNT, BLOCKLENGTH, ARRAY_OF_DISPLACEMENTS(*), OLDTYPE, NEWTYPE, IERROR
     END SUBROUTINE MPI_TYPE_CREATE_INDEXED_BLOCK
     !
     SUBROUTINE MPI_TYPE_CREATE_RESIZED(OLDTYPE, LB, EXTENT, NEWTYPE, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER OLDTYPE, NEWTYPE, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) LB, EXTENT
     END SUBROUTINE MPI_TYPE_CREATE_RESIZED
     !
     SUBROUTINE MPI_TYPE_CREATE_STRUCT(COUNT,&
          ARRAY_OF_BLOCKLENGTHS, ARRAY_OF_DISPLACEMENTS,&
          ARRAY_OF_TYPES, NEWTYPE, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER COUNT, ARRAY_OF_BLOCKLENGTHS(*), ARRAY_OF_TYPES(*), NEWTYPE, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) ARRAY_OF_DISPLACEMENTS(*)
     END SUBROUTINE MPI_TYPE_CREATE_STRUCT
     !
     SUBROUTINE MPI_TYPE_CREATE_SUBARRAY(NDIMS, ARRAY_OF_SIZES,&
          ARRAY_OF_SUBSIZES, ARRAY_OF_STARTS, ORDER, OLDTYPE, NEWTYPE,&
          IERROR)
       INTEGER NDIMS, ARRAY_OF_SIZES(*), ARRAY_OF_SUBSIZES(*),&
            ARRAY_OF_STARTS(*), ORDER, OLDTYPE, NEWTYPE, IERROR
     END SUBROUTINE MPI_TYPE_CREATE_SUBARRAY
     !
     SUBROUTINE MPI_TYPE_DUP(OLDTYPE, NEWTYPE, IERROR)
       INTEGER OLDTYPE, NEWTYPE, IERROR
     END SUBROUTINE MPI_TYPE_DUP
     !
     SUBROUTINE MPI_TYPE_FREE(DATATYPE, IERROR)
       INTEGER DATATYPE, IERROR
     END SUBROUTINE MPI_TYPE_FREE
     !
     SUBROUTINE MPI_TYPE_GET_CONTENTS(DATATYPE, MAX_INTEGERS,&
          MAX_ADDRESSES, MAX_DATATYPES, ARRAY_OF_INTEGERS,&
          ARRAY_OF_ADDRESSES, ARRAY_OF_DATATYPES, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER DATATYPE, MAX_INTEGERS, MAX_ADDRESSES, MAX_DATATYPES,&
            ARRAY_OF_INTEGERS(*), ARRAY_OF_DATATYPES(*), IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) ARRAY_OF_ADDRESSES(*)
     END SUBROUTINE MPI_TYPE_GET_CONTENTS
     !
     SUBROUTINE MPI_TYPE_GET_ENVELOPE(DATATYPE, NUM_INTEGERS,&
          NUM_ADDRESSES, NUM_DATATYPES, COMBINER, IERROR)
       INTEGER DATATYPE, NUM_INTEGERS, NUM_ADDRESSES, NUM_DATATYPES,&
            COMBINER, IERROR
     END SUBROUTINE MPI_TYPE_GET_ENVELOPE
     !
     SUBROUTINE MPI_TYPE_GET_EXTENT(DATATYPE, LB, EXTENT, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER DATATYPE, IERROR
       INTEGER(KIND = MPI_ADDRESS_KIND) LB, EXTENT
     END SUBROUTINE MPI_TYPE_GET_EXTENT
     !
     SUBROUTINE MPI_TYPE_GET_EXTENT_X(DATATYPE, LB, EXTENT, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_COUNT_KIND
       INTEGER DATATYPE, IERROR
       INTEGER(KIND=MPI_COUNT_KIND) LB, EXTENT
     END SUBROUTINE MPI_TYPE_GET_EXTENT_X
     !
     SUBROUTINE MPI_TYPE_GET_TRUE_EXTENT(DATATYPE, TRUE_LB,&
          TRUE_EXTENT, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER DATATYPE, IERROR
       INTEGER(KIND = MPI_ADDRESS_KIND) TRUE_LB, TRUE_EXTENT
     END SUBROUTINE MPI_TYPE_GET_TRUE_EXTENT
     !
     SUBROUTINE MPI_TYPE_GET_TRUE_EXTENT_X(DATATYPE, TRUE_LB, TRUE_EXTENT, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_COUNT_KIND
       INTEGER DATATYPE, IERROR
       INTEGER(KIND=MPI_COUNT_KIND) TRUE_LB, TRUE_EXTENT
     END SUBROUTINE MPI_TYPE_GET_TRUE_EXTENT_X
     !
     SUBROUTINE MPI_TYPE_INDEXED(COUNT, ARRAY_OF_BLOCKLENGTHS,&
          ARRAY_OF_DISPLACEMENTS, OLDTYPE, NEWTYPE, IERROR)
       INTEGER COUNT, ARRAY_OF_BLOCKLENGTHS(*),&
            ARRAY_OF_DISPLACEMENTS(*), OLDTYPE, NEWTYPE, IERROR
     END SUBROUTINE MPI_TYPE_INDEXED
     !
     SUBROUTINE MPI_TYPE_SIZE(DATATYPE, SIZE, IERROR)
       INTEGER DATATYPE, SIZE, IERROR
     END SUBROUTINE MPI_TYPE_SIZE
     !
     SUBROUTINE MPI_TYPE_SIZE_X(DATATYPE, SIZE, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_COUNT_KIND
       INTEGER DATATYPE, IERROR
       INTEGER(KIND=MPI_COUNT_KIND) SIZE
     END SUBROUTINE MPI_TYPE_SIZE_X
     !
     SUBROUTINE MPI_TYPE_VECTOR(COUNT, BLOCKLENGTH, STRIDE,&
          OLDTYPE, NEWTYPE, IERROR)
       INTEGER COUNT, BLOCKLENGTH, STRIDE, OLDTYPE, NEWTYPE, IERROR
     END SUBROUTINE MPI_TYPE_VECTOR
     !

     ! Collective Communication
     !
     SUBROUTINE MPI_BARRIER(COMM, IERROR)
       INTEGER COMM, IERROR
     END SUBROUTINE MPI_BARRIER
     !
     SUBROUTINE MPI_IBARRIER(COMM, REQUEST, IERROR)
       INTEGER COMM, REQUEST, IERROR
     END SUBROUTINE MPI_IBARRIER
     !
     SUBROUTINE MPI_OP_COMMUTATIVE(OP, COMMUTE, IERROR)
       LOGICAL COMMUTE
       INTEGER OP, IERROR
     END SUBROUTINE MPI_OP_COMMUTATIVE
     !
     SUBROUTINE MPI_OP_CREATE(USER_FN, COMMUTE, OP, IERROR)
       EXTERNAL USER_FN
       LOGICAL COMMUTE
       INTEGER OP, IERROR
     END SUBROUTINE MPI_OP_CREATE
     !
     SUBROUTINE MPI_OP_FREE(OP, IERROR)
       INTEGER OP, IERROR
     END SUBROUTINE MPI_OP_FREE
     !

     ! Groups, Contexts, Communicators, and Caching
     !
     SUBROUTINE MPI_COMM_COMPARE(COMM1, COMM2, RESULT, IERROR)
       INTEGER COMM1, COMM2, RESULT, IERROR
     END SUBROUTINE MPI_COMM_COMPARE
     !
     SUBROUTINE MPI_COMM_CREATE(COMM, GROUP, NEWCOMM, IERROR)
       INTEGER COMM, GROUP, NEWCOMM, IERROR
     END SUBROUTINE MPI_COMM_CREATE
     !
     SUBROUTINE MPI_COMM_CREATE_GROUP(COMM, GROUP, TAG, NEWCOMM, IERROR)
       INTEGER COMM, GROUP, TAG, NEWCOMM, IERROR
     END SUBROUTINE MPI_COMM_CREATE_GROUP
     !
     SUBROUTINE MPI_COMM_CREATE_KEYVAL(COMM_COPY_ATTR_FN,&
          COMM_DELETE_ATTR_FN, COMM_KEYVAL, EXTRA_STATE, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       EXTERNAL COMM_COPY_ATTR_FN, COMM_DELETE_ATTR_FN
       INTEGER COMM_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) EXTRA_STATE
     END SUBROUTINE MPI_COMM_CREATE_KEYVAL
     !
     SUBROUTINE MPI_COMM_DELETE_ATTR(COMM, COMM_KEYVAL, IERROR)
       INTEGER COMM, COMM_KEYVAL, IERROR
     END SUBROUTINE MPI_COMM_DELETE_ATTR
     !
     SUBROUTINE MPI_COMM_DUP(COMM, NEWCOMM, IERROR)
       INTEGER COMM, NEWCOMM, IERROR
     END SUBROUTINE MPI_COMM_DUP
     !
     SUBROUTINE MPI_COMM_DUP_FN(OLDCOMM, COMM_KEYVAL, EXTRA_STATE, ATTRIBUTE_VAL_IN,&
          ATTRIBUTE_VAL_OUT, FLAG, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER OLDCOMM, COMM_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) EXTRA_STATE, ATTRIBUTE_VAL_IN,&
            ATTRIBUTE_VAL_OUT
       LOGICAL FLAG
     END SUBROUTINE MPI_COMM_DUP_FN
     !
     SUBROUTINE MPI_COMM_DUP_WITH_INFO(COMM, INFO, NEWCOMM, IERROR)
       INTEGER COMM, INFO, NEWCOMM, IERROR
     END SUBROUTINE MPI_COMM_DUP_WITH_INFO
     !
     SUBROUTINE MPI_COMM_FREE(COMM, IERROR)
       INTEGER COMM, IERROR
     END SUBROUTINE MPI_COMM_FREE
     !
     SUBROUTINE MPI_COMM_FREE_KEYVAL(COMM_KEYVAL, IERROR)
       INTEGER COMM_KEYVAL, IERROR
     END SUBROUTINE MPI_COMM_FREE_KEYVAL
     !
     SUBROUTINE MPI_COMM_GET_ATTR(COMM, COMM_KEYVAL, ATTRIBUTE_VAL,&
          FLAG, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER COMM, COMM_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) ATTRIBUTE_VAL
       LOGICAL FLAG
     END SUBROUTINE MPI_COMM_GET_ATTR
     !
     SUBROUTINE MPI_COMM_GET_INFO(COMM, INFO_USED, IERROR)
       INTEGER COMM, INFO_USED, IERROR
     END SUBROUTINE MPI_COMM_GET_INFO
     !
     SUBROUTINE MPI_COMM_GET_NAME(COMM, COMM_NAME, RESULTLEN,&
          IERROR)
       INTEGER COMM, RESULTLEN, IERROR
       CHARACTER (LEN=*) COMM_NAME
     END SUBROUTINE MPI_COMM_GET_NAME
     !
     SUBROUTINE MPI_COMM_GROUP(COMM, GROUP, IERROR)
       INTEGER COMM, GROUP, IERROR
     END SUBROUTINE MPI_COMM_GROUP
     !
     SUBROUTINE MPI_COMM_IDUP(COMM, NEWCOMM, REQUEST, IERROR)
       INTEGER COMM, NEWCOMM, REQUEST, IERROR
     END SUBROUTINE MPI_COMM_IDUP
     !
     SUBROUTINE MPI_COMM_NULL_COPY_FN(OLDCOMM, COMM_KEYVAL, EXTRA_STATE, ATTRIBUTE_VAL_IN,&
          ATTRIBUTE_VAL_OUT, FLAG, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER OLDCOMM, COMM_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) EXTRA_STATE, ATTRIBUTE_VAL_IN,&
            ATTRIBUTE_VAL_OUT
       LOGICAL FLAG
     END SUBROUTINE MPI_COMM_NULL_COPY_FN
     !
     SUBROUTINE MPI_COMM_NULL_DELETE_FN(COMM, COMM_KEYVAL, ATTRIBUTE_VAL, EXTRA_STATE,&
          IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER COMM, COMM_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) ATTRIBUTE_VAL, EXTRA_STATE
     END SUBROUTINE MPI_COMM_NULL_DELETE_FN
     !
     SUBROUTINE MPI_COMM_RANK(COMM, RANK, IERROR)
       INTEGER COMM, RANK, IERROR
     END SUBROUTINE MPI_COMM_RANK
     !
     SUBROUTINE MPI_COMM_REMOTE_GROUP(COMM, GROUP, IERROR)
       INTEGER COMM, GROUP, IERROR
     END SUBROUTINE MPI_COMM_REMOTE_GROUP
     !
     SUBROUTINE MPI_COMM_REMOTE_SIZE(COMM, SIZE, IERROR)
       INTEGER COMM, SIZE, IERROR
     END SUBROUTINE MPI_COMM_REMOTE_SIZE
     !
     SUBROUTINE MPI_COMM_SET_ATTR(COMM, COMM_KEYVAL, ATTRIBUTE_VAL,&
          IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER COMM, COMM_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) ATTRIBUTE_VAL
     END SUBROUTINE MPI_COMM_SET_ATTR
     !
     SUBROUTINE MPI_COMM_SET_INFO(COMM, INFO, IERROR)
       INTEGER COMM, INFO, IERROR
     END SUBROUTINE MPI_COMM_SET_INFO
     !
     SUBROUTINE MPI_COMM_SET_NAME(COMM, COMM_NAME, IERROR)
       INTEGER COMM, IERROR
       CHARACTER (LEN=*) COMM_NAME
     END SUBROUTINE MPI_COMM_SET_NAME
     !
     SUBROUTINE MPI_COMM_SIZE(COMM, SIZE, IERROR)
       INTEGER COMM, SIZE, IERROR
     END SUBROUTINE MPI_COMM_SIZE
     !
     SUBROUTINE MPI_COMM_SPLIT(COMM, COLOR, KEY, NEWCOMM, IERROR)
       INTEGER COMM, COLOR, KEY, NEWCOMM, IERROR
     END SUBROUTINE MPI_COMM_SPLIT
     !
     SUBROUTINE MPI_COMM_SPLIT_TYPE(COMM, SPLIT_TYPE, KEY, INFO, NEWCOMM, IERROR)
       INTEGER COMM, SPLIT_TYPE, KEY, INFO, NEWCOMM, IERROR
     END SUBROUTINE MPI_COMM_SPLIT_TYPE
     !
     SUBROUTINE MPI_COMM_TEST_INTER(COMM, FLAG, IERROR)
       INTEGER COMM, IERROR
       LOGICAL FLAG
     END SUBROUTINE MPI_COMM_TEST_INTER
     !
     SUBROUTINE MPI_GROUP_COMPARE(GROUP1, GROUP2, RESULT, IERROR)
       INTEGER GROUP1, GROUP2, RESULT, IERROR
     END SUBROUTINE MPI_GROUP_COMPARE
     !
     SUBROUTINE MPI_GROUP_DIFFERENCE(GROUP1, GROUP2, NEWGROUP,&
          IERROR)
       INTEGER GROUP1, GROUP2, NEWGROUP, IERROR
     END SUBROUTINE MPI_GROUP_DIFFERENCE
     !
     SUBROUTINE MPI_GROUP_EXCL(GROUP, N, RANKS, NEWGROUP, IERROR)
       INTEGER GROUP, N, RANKS(*), NEWGROUP, IERROR
     END SUBROUTINE MPI_GROUP_EXCL
     !
     SUBROUTINE MPI_GROUP_FREE(GROUP, IERROR)
       INTEGER GROUP, IERROR
     END SUBROUTINE MPI_GROUP_FREE
     !
     SUBROUTINE MPI_GROUP_INCL(GROUP, N, RANKS, NEWGROUP, IERROR)
       INTEGER GROUP, N, RANKS(*), NEWGROUP, IERROR
     END SUBROUTINE MPI_GROUP_INCL
     !
     SUBROUTINE MPI_GROUP_INTERSECTION(GROUP1, GROUP2, NEWGROUP,&
          IERROR)
       INTEGER GROUP1, GROUP2, NEWGROUP, IERROR
     END SUBROUTINE MPI_GROUP_INTERSECTION
     !
     SUBROUTINE MPI_GROUP_RANGE_EXCL(GROUP, N, RANGES, NEWGROUP,&
          IERROR)
       INTEGER GROUP, N, RANGES(3,*), NEWGROUP, IERROR
     END SUBROUTINE MPI_GROUP_RANGE_EXCL
     !
     SUBROUTINE MPI_GROUP_RANGE_INCL(GROUP, N, RANGES, NEWGROUP,&
          IERROR)
       INTEGER GROUP, N, RANGES(3,*), NEWGROUP, IERROR
     END SUBROUTINE MPI_GROUP_RANGE_INCL
     !
     SUBROUTINE MPI_GROUP_RANK(GROUP, RANK, IERROR)
       INTEGER GROUP, RANK, IERROR
     END SUBROUTINE MPI_GROUP_RANK
     !
     SUBROUTINE MPI_GROUP_SIZE(GROUP, SIZE, IERROR)
       INTEGER GROUP, SIZE, IERROR
     END SUBROUTINE MPI_GROUP_SIZE
     !
     SUBROUTINE MPI_GROUP_TRANSLATE_RANKS(GROUP1, N, RANKS1,&
          GROUP2, RANKS2, IERROR)
       INTEGER GROUP1, N, RANKS1(*), GROUP2, RANKS2(*), IERROR
     END SUBROUTINE MPI_GROUP_TRANSLATE_RANKS
     !
     SUBROUTINE MPI_GROUP_UNION(GROUP1, GROUP2, NEWGROUP, IERROR)
       INTEGER GROUP1, GROUP2, NEWGROUP, IERROR
     END SUBROUTINE MPI_GROUP_UNION
     !
     SUBROUTINE MPI_INTERCOMM_CREATE(LOCAL_COMM, LOCAL_LEADER,&
          PEER_COMM, REMOTE_LEADER, TAG, NEWINTERCOMM, IERROR)
       INTEGER LOCAL_COMM, LOCAL_LEADER, PEER_COMM, REMOTE_LEADER,&
            TAG, NEWINTERCOMM, IERROR
     END SUBROUTINE MPI_INTERCOMM_CREATE
     !
     SUBROUTINE MPI_INTERCOMM_MERGE(INTERCOMM, HIGH, INTRACOMM,&
          IERROR)
       INTEGER INTERCOMM, INTRACOMM, IERROR
       LOGICAL HIGH
     END SUBROUTINE MPI_INTERCOMM_MERGE
     !
     SUBROUTINE MPI_TYPE_CREATE_KEYVAL(TYPE_COPY_ATTR_FN,&
          TYPE_DELETE_ATTR_FN, TYPE_KEYVAL, EXTRA_STATE, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       EXTERNAL TYPE_COPY_ATTR_FN, TYPE_DELETE_ATTR_FN
       INTEGER TYPE_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) EXTRA_STATE
     END SUBROUTINE MPI_TYPE_CREATE_KEYVAL
     !
     SUBROUTINE MPI_TYPE_DELETE_ATTR(TYPE, TYPE_KEYVAL, IERROR)
       INTEGER TYPE, TYPE_KEYVAL, IERROR
     END SUBROUTINE MPI_TYPE_DELETE_ATTR
     !
     SUBROUTINE MPI_TYPE_DUP_FN(OLDTYPE, TYPE_KEYVAL, EXTRA_STATE, ATTRIBUTE_VAL_IN,&
          ATTRIBUTE_VAL_OUT, FLAG, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER OLDTYPE, TYPE_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) EXTRA_STATE, ATTRIBUTE_VAL_IN,&
            ATTRIBUTE_VAL_OUT
       LOGICAL FLAG
     END SUBROUTINE MPI_TYPE_DUP_FN
     !
     SUBROUTINE MPI_TYPE_FREE_KEYVAL(TYPE_KEYVAL, IERROR)
       INTEGER TYPE_KEYVAL, IERROR
     END SUBROUTINE MPI_TYPE_FREE_KEYVAL
     !
     SUBROUTINE MPI_TYPE_GET_ATTR(DATATYPE, TYPE_KEYVAL, ATTRIBUTE_VAL,&
          FLAG, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER DATATYPE, TYPE_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) ATTRIBUTE_VAL
       LOGICAL FLAG
     END SUBROUTINE MPI_TYPE_GET_ATTR
     !
     SUBROUTINE MPI_TYPE_GET_NAME(DATATYPE, TYPE_NAME, RESULTLEN,&
          IERROR)
       INTEGER DATATYPE, RESULTLEN, IERROR
       CHARACTER (LEN=*) TYPE_NAME
     END SUBROUTINE MPI_TYPE_GET_NAME
     !
     SUBROUTINE MPI_TYPE_NULL_COPY_FN(OLDTYPE, TYPE_KEYVAL, EXTRA_STATE, ATTRIBUTE_VAL_IN,&
          ATTRIBUTE_VAL_OUT, FLAG, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER OLDTYPE, TYPE_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) EXTRA_STATE, ATTRIBUTE_VAL_IN,&
            ATTRIBUTE_VAL_OUT
       LOGICAL FLAG
     END SUBROUTINE MPI_TYPE_NULL_COPY_FN
     !
     SUBROUTINE MPI_TYPE_NULL_DELETE_FN(DATATYPE, TYPE_KEYVAL, ATTRIBUTE_VAL, EXTRA_STATE,&
          IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER DATATYPE, TYPE_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) ATTRIBUTE_VAL, EXTRA_STATE
     END SUBROUTINE MPI_TYPE_NULL_DELETE_FN
     !
     SUBROUTINE MPI_TYPE_SET_ATTR(DATATYPE, TYPE_KEYVAL, ATTRIBUTE_VAL,&
          IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER DATATYPE, TYPE_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) ATTRIBUTE_VAL
     END SUBROUTINE MPI_TYPE_SET_ATTR
     !
     SUBROUTINE MPI_TYPE_SET_NAME(DATATYPE, TYPE_NAME, IERROR)
       INTEGER DATATYPE, IERROR
       CHARACTER (LEN=*) TYPE_NAME
     END SUBROUTINE MPI_TYPE_SET_NAME
     !
     SUBROUTINE MPI_WIN_CREATE_KEYVAL(WIN_COPY_ATTR_FN,&
          WIN_DELETE_ATTR_FN, WIN_KEYVAL, EXTRA_STATE, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       EXTERNAL WIN_COPY_ATTR_FN, WIN_DELETE_ATTR_FN
       INTEGER WIN_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) EXTRA_STATE
     END SUBROUTINE MPI_WIN_CREATE_KEYVAL
     !
     SUBROUTINE MPI_WIN_DELETE_ATTR(WIN, WIN_KEYVAL, IERROR)
       INTEGER WIN, WIN_KEYVAL, IERROR
     END SUBROUTINE MPI_WIN_DELETE_ATTR
     !
     SUBROUTINE MPI_WIN_DUP_FN(OLDWIN, WIN_KEYVAL, EXTRA_STATE, ATTRIBUTE_VAL_IN,&
          ATTRIBUTE_VAL_OUT, FLAG, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER OLDWIN, WIN_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) EXTRA_STATE, ATTRIBUTE_VAL_IN,&
            ATTRIBUTE_VAL_OUT
       LOGICAL FLAG
     END SUBROUTINE MPI_WIN_DUP_FN
     !
     SUBROUTINE MPI_WIN_FREE_KEYVAL(WIN_KEYVAL, IERROR)
       INTEGER WIN_KEYVAL, IERROR
     END SUBROUTINE MPI_WIN_FREE_KEYVAL
     !
     SUBROUTINE MPI_WIN_GET_ATTR(WIN, WIN_KEYVAL, ATTRIBUTE_VAL,&
          FLAG, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER WIN, WIN_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) ATTRIBUTE_VAL
       LOGICAL FLAG
     END SUBROUTINE MPI_WIN_GET_ATTR
     !
     SUBROUTINE MPI_WIN_GET_NAME(WIN, WIN_NAME, RESULTLEN, IERROR)
       INTEGER WIN, RESULTLEN, IERROR
       CHARACTER (LEN=*) WIN_NAME
     END SUBROUTINE MPI_WIN_GET_NAME
     !
     SUBROUTINE MPI_WIN_NULL_COPY_FN (OLDWIN, WIN_KEYVAL, EXTRA_STATE, ATTRIBUTE_VAL_IN,&
          ATTRIBUTE_VAL_OUT, FLAG, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER OLDWIN, WIN_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) EXTRA_STATE, ATTRIBUTE_VAL_IN,&
            ATTRIBUTE_VAL_OUT
       LOGICAL FLAG
     END SUBROUTINE MPI_WIN_NULL_COPY_FN
     !
     SUBROUTINE MPI_WIN_NULL_DELETE_FN(WIN, WIN_KEYVAL, ATTRIBUTE_VAL, EXTRA_STATE, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER WIN, WIN_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) ATTRIBUTE_VAL, EXTRA_STATE
     END SUBROUTINE MPI_WIN_NULL_DELETE_FN
     !
     SUBROUTINE MPI_WIN_SET_ATTR(WIN, WIN_KEYVAL, ATTRIBUTE_VAL,&
          IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER WIN, WIN_KEYVAL, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) ATTRIBUTE_VAL
     END SUBROUTINE MPI_WIN_SET_ATTR
     !
     SUBROUTINE MPI_WIN_SET_NAME(WIN, WIN_NAME, IERROR)
       INTEGER WIN, IERROR
       CHARACTER (LEN=*) WIN_NAME
     END SUBROUTINE MPI_WIN_SET_NAME
     !

     ! Process Topologies
     !
     SUBROUTINE MPI_CARTDIM_GET(COMM, NDIMS, IERROR)
       INTEGER COMM, NDIMS, IERROR
     END SUBROUTINE MPI_CARTDIM_GET
     !
     SUBROUTINE MPI_CART_COORDS(COMM, RANK, MAXDIMS, COORDS,&
          IERROR)
       INTEGER COMM, RANK, MAXDIMS, COORDS(*), IERROR
     END SUBROUTINE MPI_CART_COORDS
     !
     SUBROUTINE MPI_CART_CREATE(COMM_OLD, NDIMS, DIMS, PERIODS,&
          REORDER, COMM_CART, IERROR)
       INTEGER COMM_OLD, NDIMS, DIMS(*), COMM_CART, IERROR
       LOGICAL PERIODS(*), REORDER
     END SUBROUTINE MPI_CART_CREATE
     !
     SUBROUTINE MPI_CART_GET(COMM, MAXDIMS, DIMS, PERIODS, COORDS,&
          IERROR)
       INTEGER COMM, MAXDIMS, DIMS(*), COORDS(*), IERROR
       LOGICAL PERIODS(*)
     END SUBROUTINE MPI_CART_GET
     !
     SUBROUTINE MPI_CART_MAP(COMM, NDIMS, DIMS, PERIODS, NEWRANK,&
          IERROR)
       INTEGER COMM, NDIMS, DIMS(*), NEWRANK, IERROR
       LOGICAL PERIODS(*)
     END SUBROUTINE MPI_CART_MAP
     !
     SUBROUTINE MPI_CART_RANK(COMM, COORDS, RANK, IERROR)
       INTEGER COMM, COORDS(*), RANK, IERROR
     END SUBROUTINE MPI_CART_RANK
     !
     SUBROUTINE MPI_CART_SHIFT(COMM, DIRECTION, DISP, RANK_SOURCE,&
          RANK_DEST, IERROR)
       INTEGER COMM, DIRECTION, DISP, RANK_SOURCE, RANK_DEST, IERROR
     END SUBROUTINE MPI_CART_SHIFT
     !
     SUBROUTINE MPI_CART_SUB(COMM, REMAIN_DIMS, NEWCOMM, IERROR)
       INTEGER COMM, NEWCOMM, IERROR
       LOGICAL REMAIN_DIMS(*)
     END SUBROUTINE MPI_CART_SUB
     !
     SUBROUTINE MPI_DIMS_CREATE(NNODES, NDIMS, DIMS, IERROR)
       INTEGER NNODES, NDIMS, DIMS(*), IERROR
     END SUBROUTINE MPI_DIMS_CREATE
     !
     SUBROUTINE MPI_DIST_GRAPH_NEIGHBORS_COUNT(COMM, INDEGREE, OUTDEGREE, WEIGHTED, IERROR)
       INTEGER COMM, INDEGREE, OUTDEGREE, IERROR
       LOGICAL WEIGHTED
     END SUBROUTINE MPI_DIST_GRAPH_NEIGHBORS_COUNT
     !
     SUBROUTINE MPI_GRAPHDIMS_GET(COMM, NNODES, NEDGES, IERROR)
       INTEGER COMM, NNODES, NEDGES, IERROR
     END SUBROUTINE MPI_GRAPHDIMS_GET
     !
     SUBROUTINE MPI_GRAPH_CREATE(COMM_OLD, NNODES, INDEX, EDGES,&
          REORDER, COMM_GRAPH, IERROR)
       INTEGER COMM_OLD, NNODES, INDEX(*), EDGES(*), COMM_GRAPH,&
            IERROR
       LOGICAL REORDER
     END SUBROUTINE MPI_GRAPH_CREATE
     !
     SUBROUTINE MPI_GRAPH_GET(COMM, MAXINDEX, MAXEDGES, INDEX,&
          EDGES, IERROR)
       INTEGER COMM, MAXINDEX, MAXEDGES, INDEX(*), EDGES(*), IERROR
     END SUBROUTINE MPI_GRAPH_GET
     !
     SUBROUTINE MPI_GRAPH_MAP(COMM, NNODES, INDEX, EDGES, NEWRANK,&
          IERROR)
       INTEGER COMM, NNODES, INDEX(*), EDGES(*), NEWRANK, IERROR
     END SUBROUTINE MPI_GRAPH_MAP
     !
     SUBROUTINE MPI_GRAPH_NEIGHBORS(COMM, RANK, MAXNEIGHBORS,&
          NEIGHBORS, IERROR)
       INTEGER COMM, RANK, MAXNEIGHBORS, NEIGHBORS(*), IERROR
     END SUBROUTINE MPI_GRAPH_NEIGHBORS
     !
     SUBROUTINE MPI_GRAPH_NEIGHBORS_COUNT(COMM, RANK, NNEIGHBORS,&
          IERROR)
       INTEGER COMM, RANK, NNEIGHBORS, IERROR
     END SUBROUTINE MPI_GRAPH_NEIGHBORS_COUNT
     !
     SUBROUTINE MPI_TOPO_TEST(COMM, STATUS, IERROR)
       INTEGER COMM, STATUS, IERROR
     END SUBROUTINE MPI_TOPO_TEST
     !

     ! MPI Environmental Management
     !
     FUNCTION MPI_WTIME()
       DOUBLE PRECISION MPI_WTIME
     END FUNCTION MPI_WTIME
     !
     FUNCTION MPI_WTICK()
       DOUBLE PRECISION MPI_WTICK
     END FUNCTION MPI_WTICK
     !
     SUBROUTINE MPI_ABORT(COMM, ERRORCODE, IERROR)
       INTEGER COMM, ERRORCODE, IERROR
     END SUBROUTINE MPI_ABORT
     !
     SUBROUTINE MPI_ADD_ERROR_CLASS(ERRORCLASS, IERROR)
       INTEGER ERRORCLASS, IERROR
     END SUBROUTINE MPI_ADD_ERROR_CLASS
     !
     SUBROUTINE MPI_ADD_ERROR_CODE(ERRORCLASS, ERRORCODE, IERROR)
       INTEGER ERRORCLASS, ERRORCODE, IERROR
     END SUBROUTINE MPI_ADD_ERROR_CODE
     !
     SUBROUTINE MPI_ADD_ERROR_STRING(ERRORCODE, STRING, IERROR)
       INTEGER ERRORCODE, IERROR
       CHARACTER (LEN=*) STRING
     END SUBROUTINE MPI_ADD_ERROR_STRING
     !
     SUBROUTINE MPI_COMM_CALL_ERRHANDLER(COMM, ERRORCODE, IERROR)
       INTEGER COMM, ERRORCODE, IERROR
     END SUBROUTINE MPI_COMM_CALL_ERRHANDLER
     !
     SUBROUTINE MPI_COMM_CREATE_ERRHANDLER(COMM_ERRHANDLER_FN, ERRHANDLER,&
          IERROR)
       EXTERNAL COMM_ERRHANDLER_FN
       INTEGER ERRHANDLER, IERROR
     END SUBROUTINE MPI_COMM_CREATE_ERRHANDLER
     !
     SUBROUTINE MPI_COMM_GET_ERRHANDLER(COMM, ERRHANDLER, IERROR)
       INTEGER COMM, ERRHANDLER, IERROR
     END SUBROUTINE MPI_COMM_GET_ERRHANDLER
     !
     SUBROUTINE MPI_COMM_SET_ERRHANDLER(COMM, ERRHANDLER, IERROR)
       INTEGER COMM, ERRHANDLER, IERROR
     END SUBROUTINE MPI_COMM_SET_ERRHANDLER
     !
     SUBROUTINE MPI_ERRHANDLER_FREE(ERRHANDLER, IERROR)
       INTEGER ERRHANDLER, IERROR
     END SUBROUTINE MPI_ERRHANDLER_FREE
     !
     SUBROUTINE MPI_ERROR_CLASS(ERRORCODE, ERRORCLASS, IERROR)
       INTEGER ERRORCODE, ERRORCLASS, IERROR
     END SUBROUTINE MPI_ERROR_CLASS
     !
     SUBROUTINE MPI_ERROR_STRING(ERRORCODE, STRING, RESULTLEN,&
          IERROR)
       INTEGER ERRORCODE, RESULTLEN, IERROR
       CHARACTER (LEN=*) STRING
     END SUBROUTINE MPI_ERROR_STRING
     !
     SUBROUTINE MPI_FILE_CALL_ERRHANDLER(FH, ERRORCODE, IERROR)
       INTEGER FH, ERRORCODE, IERROR
     END SUBROUTINE MPI_FILE_CALL_ERRHANDLER
     !
     SUBROUTINE MPI_FILE_CREATE_ERRHANDLER(FILE_ERRHANDLER_FN, ERRHANDLER,&
          IERROR)
       EXTERNAL FILE_ERRHANDLER_FN
       INTEGER ERRHANDLER, IERROR
     END SUBROUTINE MPI_FILE_CREATE_ERRHANDLER
     !
     SUBROUTINE MPI_FILE_GET_ERRHANDLER(FILE, ERRHANDLER, IERROR)
       INTEGER FILE, ERRHANDLER, IERROR
     END SUBROUTINE MPI_FILE_GET_ERRHANDLER
     !
     SUBROUTINE MPI_FILE_SET_ERRHANDLER(FILE, ERRHANDLER, IERROR)
       INTEGER FILE, ERRHANDLER, IERROR
     END SUBROUTINE MPI_FILE_SET_ERRHANDLER
     !
     SUBROUTINE MPI_FINALIZE(IERROR)
       INTEGER IERROR
     END SUBROUTINE MPI_FINALIZE
     !
     SUBROUTINE MPI_FINALIZED(FLAG, IERROR)
       LOGICAL FLAG
       INTEGER IERROR
     END SUBROUTINE MPI_FINALIZED
     !
     SUBROUTINE MPI_GET_LIBRARY_VERSION(VERSION, RESULTLEN, IERROR)
       CHARACTER (LEN=*) VERSION
       INTEGER RESULTLEN, IERROR
     END SUBROUTINE MPI_GET_LIBRARY_VERSION
     !
     SUBROUTINE MPI_GET_PROCESSOR_NAME(NAME, RESULTLEN, IERROR)
       CHARACTER (LEN=*) NAME
       INTEGER RESULTLEN, IERROR
     END SUBROUTINE MPI_GET_PROCESSOR_NAME
     !
     SUBROUTINE MPI_GET_VERSION(VERSION, SUBVERSION, IERROR)
       INTEGER VERSION, SUBVERSION, IERROR
     END SUBROUTINE MPI_GET_VERSION
     !
     SUBROUTINE MPI_INIT(IERROR)
       INTEGER IERROR
     END SUBROUTINE MPI_INIT
     !
     SUBROUTINE MPI_INITIALIZED(FLAG, IERROR)
       LOGICAL FLAG
       INTEGER IERROR
     END SUBROUTINE MPI_INITIALIZED
     !
     SUBROUTINE MPI_WIN_CALL_ERRHANDLER(WIN, ERRORCODE, IERROR)
       INTEGER WIN, ERRORCODE, IERROR
     END SUBROUTINE MPI_WIN_CALL_ERRHANDLER
     !
     SUBROUTINE MPI_WIN_CREATE_ERRHANDLER(WIN_ERRHANDLER_FN, ERRHANDLER,&
          IERROR)
       EXTERNAL WIN_ERRHANDLER_FN
       INTEGER ERRHANDLER, IERROR
     END SUBROUTINE MPI_WIN_CREATE_ERRHANDLER
     !
     SUBROUTINE MPI_WIN_GET_ERRHANDLER(WIN, ERRHANDLER, IERROR)
       INTEGER WIN, ERRHANDLER, IERROR
     END SUBROUTINE MPI_WIN_GET_ERRHANDLER
     !
     SUBROUTINE MPI_WIN_SET_ERRHANDLER(WIN, ERRHANDLER, IERROR)
       INTEGER WIN, ERRHANDLER, IERROR
     END SUBROUTINE MPI_WIN_SET_ERRHANDLER
     !

     ! The Info Object
     !
     SUBROUTINE MPI_INFO_CREATE(INFO, IERROR)
       INTEGER INFO, IERROR
     END SUBROUTINE MPI_INFO_CREATE
     !
     SUBROUTINE MPI_INFO_DELETE(INFO, KEY, IERROR)
       INTEGER INFO, IERROR
       CHARACTER (LEN=*) KEY
     END SUBROUTINE MPI_INFO_DELETE
     !
     SUBROUTINE MPI_INFO_DUP(INFO, NEWINFO, IERROR)
       INTEGER INFO, NEWINFO, IERROR
     END SUBROUTINE MPI_INFO_DUP
     !
     SUBROUTINE MPI_INFO_FREE(INFO, IERROR)
       INTEGER INFO, IERROR
     END SUBROUTINE MPI_INFO_FREE
     !
     SUBROUTINE MPI_INFO_GET(INFO, KEY, VALUELEN, VALUE, FLAG,&
          IERROR)
       INTEGER INFO, VALUELEN, IERROR
       CHARACTER (LEN=*) KEY, VALUE
       LOGICAL FLAG
     END SUBROUTINE MPI_INFO_GET
     !
     SUBROUTINE MPI_INFO_GET_NKEYS(INFO, NKEYS, IERROR)
       INTEGER INFO, NKEYS, IERROR
     END SUBROUTINE MPI_INFO_GET_NKEYS
     !
     SUBROUTINE MPI_INFO_GET_NTHKEY(INFO, N, KEY, IERROR)
       INTEGER INFO, N, IERROR
       CHARACTER (LEN=*) KEY
     END SUBROUTINE MPI_INFO_GET_NTHKEY
     !
     SUBROUTINE MPI_INFO_GET_VALUELEN(INFO, KEY, VALUELEN, FLAG,&
          IERROR)
       INTEGER INFO, VALUELEN, IERROR
       LOGICAL FLAG
       CHARACTER (LEN=*) KEY
     END SUBROUTINE MPI_INFO_GET_VALUELEN
     !
     SUBROUTINE MPI_INFO_SET(INFO, KEY, VALUE, IERROR)
       INTEGER INFO, IERROR
       CHARACTER (LEN=*) KEY, VALUE
     END SUBROUTINE MPI_INFO_SET
     !

     ! Process Creation and Management
     !
     SUBROUTINE MPI_CLOSE_PORT(PORT_NAME, IERROR)
       CHARACTER (LEN=*) PORT_NAME
       INTEGER IERROR
     END SUBROUTINE MPI_CLOSE_PORT
     !
     SUBROUTINE MPI_COMM_ACCEPT(PORT_NAME, INFO, ROOT, COMM,&
          NEWCOMM, IERROR)
       CHARACTER (LEN=*) PORT_NAME
       INTEGER INFO, ROOT, COMM, NEWCOMM, IERROR
     END SUBROUTINE MPI_COMM_ACCEPT
     !
     SUBROUTINE MPI_COMM_CONNECT(PORT_NAME, INFO, ROOT, COMM,&
          NEWCOMM, IERROR)
       CHARACTER (LEN=*) PORT_NAME
       INTEGER INFO, ROOT, COMM, NEWCOMM, IERROR
     END SUBROUTINE MPI_COMM_CONNECT
     !
     SUBROUTINE MPI_COMM_DISCONNECT(COMM, IERROR)
       INTEGER COMM, IERROR
     END SUBROUTINE MPI_COMM_DISCONNECT
     !
     SUBROUTINE MPI_COMM_GET_PARENT(PARENT, IERROR)
       INTEGER PARENT, IERROR
     END SUBROUTINE MPI_COMM_GET_PARENT
     !
     SUBROUTINE MPI_COMM_JOIN(FD, INTERCOMM, IERROR)
       INTEGER FD, INTERCOMM, IERROR
     END SUBROUTINE MPI_COMM_JOIN
     !
     SUBROUTINE MPI_COMM_SPAWN(COMMAND, ARGV, MAXPROCS, INFO, ROOT,&
          COMM, INTERCOMM, ARRAY_OF_ERRCODES, IERROR)
       CHARACTER (LEN=*) COMMAND, ARGV(*)
       INTEGER INFO, MAXPROCS, ROOT, COMM, INTERCOMM,&
            ARRAY_OF_ERRCODES(*), IERROR
     END SUBROUTINE MPI_COMM_SPAWN
     !
     SUBROUTINE MPI_COMM_SPAWN_MULTIPLE(COUNT, ARRAY_OF_COMMANDS,&
          ARRAY_OF_ARGV, ARRAY_OF_MAXPROCS, ARRAY_OF_INFO, ROOT, COMM,&
          INTERCOMM, ARRAY_OF_ERRCODES, IERROR)
       INTEGER COUNT, ARRAY_OF_INFO(*), ARRAY_OF_MAXPROCS(*), ROOT,&
            COMM, INTERCOMM, ARRAY_OF_ERRCODES(*), IERROR
       CHARACTER (LEN=*) ARRAY_OF_COMMANDS(*), ARRAY_OF_ARGV(COUNT, *)
     END SUBROUTINE MPI_COMM_SPAWN_MULTIPLE
     !
     SUBROUTINE MPI_LOOKUP_NAME(SERVICE_NAME, INFO, PORT_NAME,&
          IERROR)
       CHARACTER (LEN=*) SERVICE_NAME, PORT_NAME
       INTEGER INFO, IERROR
     END SUBROUTINE MPI_LOOKUP_NAME
     !
     SUBROUTINE MPI_OPEN_PORT(INFO, PORT_NAME, IERROR)
       CHARACTER (LEN=*) PORT_NAME
       INTEGER INFO, IERROR
     END SUBROUTINE MPI_OPEN_PORT
     !
     SUBROUTINE MPI_PUBLISH_NAME(SERVICE_NAME, INFO, PORT_NAME,&
          IERROR)
       INTEGER INFO, IERROR
       CHARACTER (LEN=*) SERVICE_NAME, PORT_NAME
     END SUBROUTINE MPI_PUBLISH_NAME
     !
     SUBROUTINE MPI_UNPUBLISH_NAME(SERVICE_NAME, INFO, PORT_NAME,&
          IERROR)
       INTEGER INFO, IERROR
       CHARACTER (LEN=*) SERVICE_NAME, PORT_NAME
     END SUBROUTINE MPI_UNPUBLISH_NAME
     !

     ! One-Sided Communications
     !
     SUBROUTINE MPI_WIN_COMPLETE(WIN, IERROR)
       INTEGER WIN, IERROR
     END SUBROUTINE MPI_WIN_COMPLETE
     !
     SUBROUTINE MPI_WIN_CREATE_DYNAMIC(INFO, COMM, WIN, IERROR)
       INTEGER INFO, COMM, WIN, IERROR
     END SUBROUTINE MPI_WIN_CREATE_DYNAMIC
     !
     SUBROUTINE MPI_WIN_FENCE(ASSERT, WIN, IERROR)
       INTEGER ASSERT, WIN, IERROR
     END SUBROUTINE MPI_WIN_FENCE
     !
     SUBROUTINE MPI_WIN_FLUSH(RANK, WIN, IERROR)
       INTEGER RANK, WIN, IERROR
     END SUBROUTINE MPI_WIN_FLUSH
     !
     SUBROUTINE MPI_WIN_FLUSH_ALL(WIN, IERROR)
       INTEGER WIN, IERROR
     END SUBROUTINE MPI_WIN_FLUSH_ALL
     !
     SUBROUTINE MPI_WIN_FLUSH_LOCAL(RANK, WIN, IERROR)
       INTEGER RANK, WIN, IERROR
     END SUBROUTINE MPI_WIN_FLUSH_LOCAL
     !
     SUBROUTINE MPI_WIN_FLUSH_LOCAL_ALL(WIN, IERROR)
       INTEGER WIN, IERROR
     END SUBROUTINE MPI_WIN_FLUSH_LOCAL_ALL
     !
     SUBROUTINE MPI_WIN_FREE(WIN, IERROR)
       INTEGER WIN, IERROR
     END SUBROUTINE MPI_WIN_FREE
     !
     SUBROUTINE MPI_WIN_GET_GROUP(WIN, GROUP, IERROR)
       INTEGER WIN, GROUP, IERROR
     END SUBROUTINE MPI_WIN_GET_GROUP
     !
     SUBROUTINE MPI_WIN_GET_INFO(WIN, INFO_USED, IERROR)
       INTEGER WIN, INFO_USED, IERROR
     END SUBROUTINE MPI_WIN_GET_INFO
     !
     SUBROUTINE MPI_WIN_LOCK(LOCK_TYPE, RANK, ASSERT, WIN, IERROR)
       INTEGER LOCK_TYPE, RANK, ASSERT, WIN, IERROR
     END SUBROUTINE MPI_WIN_LOCK
     !
     SUBROUTINE MPI_WIN_LOCK_ALL(ASSERT, WIN, IERROR)
       INTEGER ASSERT, WIN, IERROR
     END SUBROUTINE MPI_WIN_LOCK_ALL
     !
     SUBROUTINE MPI_WIN_POST(GROUP, ASSERT, WIN, IERROR)
       INTEGER GROUP, ASSERT, WIN, IERROR
     END SUBROUTINE MPI_WIN_POST
     !
     SUBROUTINE MPI_WIN_SET_INFO(WIN, INFO, IERROR)
       INTEGER WIN, INFO, IERROR
     END SUBROUTINE MPI_WIN_SET_INFO
     !
     SUBROUTINE MPI_WIN_START(GROUP, ASSERT, WIN, IERROR)
       INTEGER GROUP, ASSERT, WIN, IERROR
     END SUBROUTINE MPI_WIN_START
     !
     SUBROUTINE MPI_WIN_SYNC(WIN, IERROR)
       INTEGER WIN, IERROR
     END SUBROUTINE MPI_WIN_SYNC
     !
     SUBROUTINE MPI_WIN_TEST(WIN, FLAG, IERROR)
       INTEGER WIN, IERROR
       LOGICAL FLAG
     END SUBROUTINE MPI_WIN_TEST
     !
     SUBROUTINE MPI_WIN_UNLOCK(RANK, WIN, IERROR)
       INTEGER RANK, WIN, IERROR
     END SUBROUTINE MPI_WIN_UNLOCK
     !
     SUBROUTINE MPI_WIN_UNLOCK_ALL(WIN, IERROR)
       INTEGER WIN, IERROR
     END SUBROUTINE MPI_WIN_UNLOCK_ALL
     !
     SUBROUTINE MPI_WIN_WAIT(WIN, IERROR)
       INTEGER WIN, IERROR
     END SUBROUTINE MPI_WIN_WAIT
     !

     ! External Interfaces
     !
     SUBROUTINE MPI_GREQUEST_COMPLETE(REQUEST, IERROR)
       INTEGER REQUEST, IERROR
     END SUBROUTINE MPI_GREQUEST_COMPLETE
     !
     SUBROUTINE MPI_GREQUEST_START(QUERY_FN, FREE_FN, CANCEL_FN,&
          EXTRA_STATE, REQUEST, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER REQUEST, IERROR
       EXTERNAL QUERY_FN, FREE_FN, CANCEL_FN
       INTEGER (KIND=MPI_ADDRESS_KIND) EXTRA_STATE
     END SUBROUTINE MPI_GREQUEST_START
     !
     SUBROUTINE MPI_INIT_THREAD(REQUIRED, PROVIDED, IERROR)
       INTEGER REQUIRED, PROVIDED, IERROR
     END SUBROUTINE MPI_INIT_THREAD
     !
     SUBROUTINE MPI_IS_THREAD_MAIN(FLAG, IERROR)
       LOGICAL FLAG
       INTEGER IERROR
     END SUBROUTINE MPI_IS_THREAD_MAIN
     !
     SUBROUTINE MPI_QUERY_THREAD(PROVIDED, IERROR)
       INTEGER PROVIDED, IERROR
     END SUBROUTINE MPI_QUERY_THREAD
     !
     SUBROUTINE MPI_STATUS_SET_CANCELLED(STATUS, FLAG, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       INTEGER STATUS(MPI_STATUS_SIZE), IERROR
       LOGICAL FLAG
     END SUBROUTINE MPI_STATUS_SET_CANCELLED
     !
     SUBROUTINE MPI_STATUS_SET_ELEMENTS(STATUS, DATATYPE, COUNT,&
          IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE
       INTEGER STATUS(MPI_STATUS_SIZE), DATATYPE, COUNT, IERROR
     END SUBROUTINE MPI_STATUS_SET_ELEMENTS
     !
     SUBROUTINE MPI_STATUS_SET_ELEMENTS_X(STATUS, DATATYPE, COUNT, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_STATUS_SIZE, MPI_COUNT_KIND
       INTEGER STATUS(MPI_STATUS_SIZE), DATATYPE, IERROR
       INTEGER (KIND=MPI_COUNT_KIND) COUNT
     END SUBROUTINE MPI_STATUS_SET_ELEMENTS_X
     !

     ! I/O
     !
     SUBROUTINE MPI_FILE_CLOSE(FH, IERROR)
       INTEGER FH, IERROR
     END SUBROUTINE MPI_FILE_CLOSE
     !
     SUBROUTINE MPI_FILE_DELETE(FILENAME, INFO, IERROR)
       CHARACTER (LEN=*) FILENAME
       INTEGER INFO, IERROR
     END SUBROUTINE MPI_FILE_DELETE
     !
     SUBROUTINE MPI_FILE_GET_AMODE(FH, AMODE, IERROR)
       INTEGER FH, AMODE, IERROR
     END SUBROUTINE MPI_FILE_GET_AMODE
     !
     SUBROUTINE MPI_FILE_GET_ATOMICITY(FH, FLAG, IERROR)
       INTEGER FH, IERROR
       LOGICAL FLAG
     END SUBROUTINE MPI_FILE_GET_ATOMICITY
     !
     SUBROUTINE MPI_FILE_GET_BYTE_OFFSET(FH, OFFSET, DISP, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_OFFSET_KIND
       INTEGER FH, IERROR
       INTEGER(KIND=MPI_OFFSET_KIND) OFFSET, DISP
     END SUBROUTINE MPI_FILE_GET_BYTE_OFFSET
     !
     SUBROUTINE MPI_FILE_GET_GROUP(FH, GROUP, IERROR)
       INTEGER FH, GROUP, IERROR
     END SUBROUTINE MPI_FILE_GET_GROUP
     !
     SUBROUTINE MPI_FILE_GET_INFO(FH, INFO_USED, IERROR)
       INTEGER FH, INFO_USED, IERROR
     END SUBROUTINE MPI_FILE_GET_INFO
     !
     SUBROUTINE MPI_FILE_GET_POSITION(FH, OFFSET, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_OFFSET_KIND
       INTEGER FH, IERROR
       INTEGER(KIND=MPI_OFFSET_KIND) OFFSET
     END SUBROUTINE MPI_FILE_GET_POSITION
     !
     SUBROUTINE MPI_FILE_GET_POSITION_SHARED(FH, OFFSET, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_OFFSET_KIND
       INTEGER FH, IERROR
       INTEGER(KIND=MPI_OFFSET_KIND) OFFSET
     END SUBROUTINE MPI_FILE_GET_POSITION_SHARED
     !
     SUBROUTINE MPI_FILE_GET_SIZE(FH, SIZE, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_OFFSET_KIND
       INTEGER FH, IERROR
       INTEGER(KIND=MPI_OFFSET_KIND) SIZE
     END SUBROUTINE MPI_FILE_GET_SIZE
     !
     SUBROUTINE MPI_FILE_GET_TYPE_EXTENT(FH, DATATYPE, EXTENT,&
          IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       INTEGER FH, DATATYPE, IERROR
       INTEGER(KIND=MPI_ADDRESS_KIND) EXTENT
     END SUBROUTINE MPI_FILE_GET_TYPE_EXTENT
     !
     SUBROUTINE MPI_FILE_GET_VIEW(FH, DISP, ETYPE, FILETYPE,&
          DATAREP, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_OFFSET_KIND
       INTEGER FH, ETYPE, FILETYPE, IERROR
       CHARACTER (LEN=*) DATAREP
       INTEGER(KIND=MPI_OFFSET_KIND) DISP
     END SUBROUTINE MPI_FILE_GET_VIEW
     !
     SUBROUTINE MPI_FILE_OPEN(COMM, FILENAME, AMODE, INFO, FH,&
          IERROR)
       CHARACTER (LEN=*) FILENAME
       INTEGER COMM, AMODE, INFO, FH, IERROR
     END SUBROUTINE MPI_FILE_OPEN
     !
     SUBROUTINE MPI_FILE_PREALLOCATE(FH, SIZE, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_OFFSET_KIND
       INTEGER FH, IERROR
       INTEGER(KIND=MPI_OFFSET_KIND) SIZE
     END SUBROUTINE MPI_FILE_PREALLOCATE
     !
     SUBROUTINE MPI_FILE_SEEK(FH, OFFSET, WHENCE, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_OFFSET_KIND
       INTEGER FH, WHENCE, IERROR
       INTEGER(KIND=MPI_OFFSET_KIND) OFFSET
     END SUBROUTINE MPI_FILE_SEEK
     !
     SUBROUTINE MPI_FILE_SEEK_SHARED(FH, OFFSET, WHENCE, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_OFFSET_KIND
       INTEGER FH, WHENCE, IERROR
       INTEGER(KIND=MPI_OFFSET_KIND) OFFSET
     END SUBROUTINE MPI_FILE_SEEK_SHARED
     !
     SUBROUTINE MPI_FILE_SET_ATOMICITY(FH, FLAG, IERROR)
       INTEGER FH, IERROR
       LOGICAL FLAG
     END SUBROUTINE MPI_FILE_SET_ATOMICITY
     !
     SUBROUTINE MPI_FILE_SET_INFO(FH, INFO, IERROR)
       INTEGER FH, INFO, IERROR
     END SUBROUTINE MPI_FILE_SET_INFO
     !
     SUBROUTINE MPI_FILE_SET_SIZE(FH, SIZE, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_OFFSET_KIND
       INTEGER FH, IERROR
       INTEGER(KIND=MPI_OFFSET_KIND) SIZE
     END SUBROUTINE MPI_FILE_SET_SIZE
     !
     SUBROUTINE MPI_FILE_SET_VIEW(FH, DISP, ETYPE, FILETYPE,&
          DATAREP, INFO, IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_OFFSET_KIND
       INTEGER FH, ETYPE, FILETYPE, INFO, IERROR
       CHARACTER (LEN=*) DATAREP
       INTEGER(KIND=MPI_OFFSET_KIND) DISP
     END SUBROUTINE MPI_FILE_SET_VIEW
     !
     SUBROUTINE MPI_FILE_SYNC(FH, IERROR)
       INTEGER FH, IERROR
     END SUBROUTINE MPI_FILE_SYNC
     !
     SUBROUTINE MPI_REGISTER_DATAREP(DATAREP, READ_CONVERSION_FN,&
          WRITE_CONVERSION_FN, DTYPE_FILE_EXTENT_FN, EXTRA_STATE,&
          IERROR)
       USE MPI_CONSTANTS,ONLY: MPI_ADDRESS_KIND
       CHARACTER (LEN=*) DATAREP
       EXTERNAL READ_CONVERSION_FN, WRITE_CONVERSION_FN,&
            DTYPE_FILE_EXTENT_FN
       INTEGER(KIND=MPI_ADDRESS_KIND) EXTRA_STATE
       INTEGER IERROR
     END SUBROUTINE MPI_REGISTER_DATAREP
     !

     ! Language Bindings
     !
     SUBROUTINE MPI_TYPE_CREATE_F90_COMPLEX(P, R, NEWTYPE, IERROR)
       INTEGER P, R, NEWTYPE, IERROR
     END SUBROUTINE MPI_TYPE_CREATE_F90_COMPLEX
     !
     SUBROUTINE MPI_TYPE_CREATE_F90_INTEGER(R, NEWTYPE, IERROR)
       INTEGER R, NEWTYPE, IERROR
     END SUBROUTINE MPI_TYPE_CREATE_F90_INTEGER
     !
     SUBROUTINE MPI_TYPE_CREATE_F90_REAL(P, R, NEWTYPE, IERROR)
       INTEGER P, R, NEWTYPE, IERROR
     END SUBROUTINE MPI_TYPE_CREATE_F90_REAL
     !
     SUBROUTINE MPI_TYPE_MATCH_SIZE(TYPECLASS, SIZE, DATATYPE, IERROR)
       INTEGER TYPECLASS, SIZE, DATATYPE, IERROR
     END SUBROUTINE MPI_TYPE_MATCH_SIZE
     !

     ! Tools / Profiling Interface
     !
     SUBROUTINE MPI_PCONTROL(LEVEL)
       INTEGER LEVEL
     END SUBROUTINE MPI_PCONTROL

     ! Deprecated
     SUBROUTINE MPI_ATTR_DELETE(COMM, KEYVAL, IERROR)
       INTEGER COMM, KEYVAL, IERROR
     END SUBROUTINE MPI_ATTR_DELETE
     !
     SUBROUTINE MPI_ATTR_GET(COMM, KEYVAL, ATTRIBUTE_VAL, FLAG,&
          IERROR)
       INTEGER COMM, KEYVAL, ATTRIBUTE_VAL, IERROR
       LOGICAL FLAG
     END SUBROUTINE MPI_ATTR_GET
     !
     SUBROUTINE MPI_ATTR_PUT(COMM, KEYVAL, ATTRIBUTE_VAL, IERROR)
       INTEGER COMM, KEYVAL, ATTRIBUTE_VAL, IERROR
     END SUBROUTINE MPI_ATTR_PUT
     !
     SUBROUTINE MPI_DUP_FN(OLDCOMM, KEYVAL, EXTRA_STATE, ATTRIBUTE_VAL_IN,&
          ATTRIBUTE_VAL_OUT, FLAG, IERR)
       INTEGER OLDCOMM, KEYVAL, EXTRA_STATE, ATTRIBUTE_VAL_IN,&
            ATTRIBUTE_VAL_OUT, IERR
       LOGICAL FLAG
     END SUBROUTINE MPI_DUP_FN
     !
     SUBROUTINE MPI_KEYVAL_CREATE(COPY_FN, DELETE_FN, KEYVAL,&
          EXTRA_STATE, IERROR)
       EXTERNAL COPY_FN, DELETE_FN
       INTEGER KEYVAL, EXTRA_STATE, IERROR
     END SUBROUTINE MPI_KEYVAL_CREATE
     !
     SUBROUTINE MPI_KEYVAL_FREE(KEYVAL, IERROR)
       INTEGER KEYVAL, IERROR
     END SUBROUTINE MPI_KEYVAL_FREE
     !
     SUBROUTINE MPI_NULL_COPY_FN(OLDCOMM, KEYVAL, EXTRA_STATE, ATTRIBUTE_VAL_IN,&
          ATTRIBUTE_VAL_OUT, FLAG, IERR)
       INTEGER OLDCOMM, KEYVAL, EXTRA_STATE, ATTRIBUTE_VAL_IN,&
            ATTRIBUTE_VAL_OUT, IERR
       LOGICAL FLAG
     END SUBROUTINE MPI_NULL_COPY_FN
     !
     SUBROUTINE MPI_NULL_DELETE_FN(COMM, KEYVAL, ATTRIBUTE_VAL, EXTRA_STATE, IERROR)
       INTEGER COMM, KEYVAL, ATTRIBUTE_VAL, EXTRA_STATE, IERROR
     END SUBROUTINE MPI_NULL_DELETE_FN
  END INTERFACE
END MODULE MPI_BASE
