/*
 * NewMadeleine
 * Copyright (C) 2006-2021 (see AUTHORS file)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */

/** @file
 * internal definitions for interface 'onesided'.
 * Not part of the public API.
 */

#ifndef NM_ONESIDED_PRIVATE_H
#define NM_ONESIDED_PRIVATE_H

#include <nm_sendrecv_interface.h>

enum nm_onesided_op_e
  {
   NM_ONESIDED_OP_PUT = 1,
   NM_ONESIDED_OP_GET,
   NM_ONESIDED_OP_FENCE
  };

struct nm_onesided_header_s
{
  uintptr_t addr;
  nm_len_t size;
  uint32_t flags;
};

struct nm_onesided_request_s
{
  nm_sr_request_t sr_req;
  struct nm_onesided_header_s header;
};

PUK_ALLOCATOR_TYPE(nm_sr_req, nm_sr_request_t);

/** an instance of interface 'onesided' */
struct nm_onesided_s
{
  nm_session_t p_session;
  struct nm_onesided_request_s request; /** persistent request for recv */
  struct nm_data_s data; /** data descriptor for recv; persistant accross handlers for RECV_DATA and FINALIZED */
  struct nm_data_s data_body;
  nm_sr_req_allocator_t req_allocator;
  int running;
  nm_cond_status_t done;
};

#endif /* NM_ONESIDED_PRIVATE_H */
